"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
class ConfigurationManager {
    constructor() {
        this._configUpdatedListeners = new Set();
        this._configuration = ConfigurationManager.defaultConfiguration;
    }
    get config() {
        return this._configuration;
    }
    equalTo(other) {
        return (this._configuration.enable === other.enable &&
            this._configuration.dtsPath === other.dtsPath &&
            this._configuration.import_map === other.import_map);
    }
    update(config) {
        this._configuration = Object.assign(Object.assign({}, this._configuration), config);
        if (!this.equalTo(config)) {
            for (const listener of this._configUpdatedListeners) {
                listener();
            }
        }
    }
    onUpdatedConfig(listener) {
        this._configUpdatedListeners.add(listener);
    }
}
exports.ConfigurationManager = ConfigurationManager;
ConfigurationManager.defaultConfiguration = {
    enable: false,
    import_map: "",
    dtsPath: undefined,
};
//# sourceMappingURL=configuration.js.map